# Enum Class DrbgParameters.Capability

java.lang.Object
java.lang.Enum<DrbgParameters.Capability>
java.security.DrbgParameters.Capability

All Implemented Interfaces:
  `Serializable, Comparable<DrbgParameters.Capability>, Constable`

Enclosing class:
  `DrbgParameters`

public static enum DrbgParameters.Capability extends Enum<DrbgParameters.Capability>
The reseedable and prediction resistance capabilities of a DRBG.

When this object is passed to a `SecureRandom.getInstance()` call, it is the requested minimum capability. When it's returned from `SecureRandom.getParameters()`, it is the effective capability.

Please note that while the `Instantiate_function` defined in NIST SP 800-90Ar1 only includes a `prediction_resistance_flag` parameter, the `Capability` type includes an extra value `RESEED_ONLY` because reseeding is an optional function. If `NONE` is used in an `Instantiation` object in calling the `SecureRandom.getInstance` method, the returned DRBG instance is not guaranteed to support reseeding. If `RESEED_ONLY` or `PR_AND_RESEED` is used, the instance must support reseeding.

The table below lists possible effective values if a certain capability is requested, i.e.

>     Capability requested = ...;
>     SecureRandom s = SecureRandom.getInstance("DRBG",
>             DrbgParameters(-1, requested, null));
>     Capability effective = ((DrbgParametes.Initiate) s.getParameters())
>             .getCapability();

requested and effective capabilities
Requested Value | Possible Effective Values
--- | ---
NONE | NONE, RESEED_ONLY, PR_AND_RESEED
RESEED_ONLY | RESEED_ONLY, PR_AND_RESEED
PR_AND_RESEED | PR_AND_RESEED

A DRBG implementation supporting prediction resistance must also support reseeding.

Since:
  9

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `NONE`
  Neither prediction resistance nor reseed.
  `PR_AND_RESEED`
  Both prediction resistance and reseed.
  `RESEED_ONLY`
  Reseed but no prediction resistance.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `supportsPredictionResistance()`
  Returns whether this capability supports prediction resistance.
  `boolean`
  `supportsReseeding()`
  Returns whether this capability supports reseeding.
  `static DrbgParameters.Capability`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static DrbgParameters.Capability[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(DrbgParameters.Capability o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<DrbgParameters.Capability>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<DrbgParameters.Capability>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### PR_AND_RESEED

    public static final DrbgParameters.Capability PR_AND_RESEED
    Both prediction resistance and reseed.

  - ### RESEED_ONLY

    public static final DrbgParameters.Capability RESEED_ONLY
    Reseed but no prediction resistance.

  - ### NONE

    public static final DrbgParameters.Capability NONE
    Neither prediction resistance nor reseed.

- ## Method Details

  - ### values

    public static DrbgParameters.Capability[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static DrbgParameters.Capability valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### supportsReseeding

    public boolean supportsReseeding()
    Returns whether this capability supports reseeding.
    Returns:
      `true` for `PR_AND_RESEED` and `RESEED_ONLY`, and `false` for `NONE`

  - ### supportsPredictionResistance

    public boolean supportsPredictionResistance()
    Returns whether this capability supports prediction resistance.
    Returns:
      `true` for `PR_AND_RESEED`, and `false` for `RESEED_ONLY` and `NONE`